#! /bin/sh
./utilities/install-git-hooks.sh
autoreconf --install --force
version=`grep -m1 ^AC_INIT configure.ac | cut -d, -f 2 | tr -d ' '`
version_extra=`utilities/git-desc.sh`
echo "${version}-${version_extra}"
# debian package cannot be built after running configure as dpkg-buildpackage
# will fail if the source directory is not clean so generate changelog here.
sed -e "s/@VERSION@/$version/g" -e "s/@RELEASE@/$version_extra/g" \
    debian/changelog.in > debian/changelog
# also prepare the spec rpm without the need to run configure.
version_extra=`echo $version_extra | tr - _`
sed -e "s/@VERSION@/$version/g" -e "s/@RELEASE@/$version_extra/g" \
    rhel/doca-openvswitch.spec.in > rhel/doca-openvswitch.spec

echo "Bootstrap done, you might want to execute ./utilities/install-deps.sh"
