#!/bin/bash

srcdir=$PWD
[ "${srcdir}" != "${srcdir%%'/debian/build'}" ] && srcdir="$srcdir/../.."
boot_git_sha="$srcdir/boot_git_sha.txt"
if test -e "$srcdir/.git" && (git --version) >/dev/null 2>&1; then
    EXTRA=$(grep -m1 -E "^RELEASE_EXTRA = " "$srcdir/Makefile.am" | cut -d = -f 2 | tr -d ' ' 2>/dev/null)
    [ "$EXTRA" ] && EXTRA="-$EXTRA"
    RELEASE_DESC=$(git describe --tags --match "[0-9]*.[0-9]*.[0-9]*" 2>/dev/null)
    [ "$RELEASE_DESC" ] && RELEASE_DESC=$(echo "$RELEASE_DESC" | cut -d - -f 2- 2>/dev/null)
    [ "$RELEASE_DESC" ] || RELEASE_DESC=$(git rev-parse --short HEAD 3>/dev/null)
    [ "$RELEASE_DESC" ] && echo "$RELEASE_DESC$EXTRA" > "$boot_git_sha"
fi
cat "$boot_git_sha" 2>/dev/null
